unit contextm;

interface

uses
  Windows, ActiveX, ComObj, ShlObj, Classes, comserv;

type

  { TContextMenu }

  TContextMenu = class(TComObject, IShellExtInit, IContextMenu)
  private
    FFileName: array [0 .. 260] of char;
  protected
    function IShellExtInit.Initialize = SEIInitialize;
    function SEIInitialize(pidlFolder: PItemIDList; lpdobj: IDataObject;
      hKeyProgID: HKEY): HResult; stdcall;
    function QueryContextMenu(Menu: HMENU;
      indexMenu, idCmdFirst, idCmdLast, uFlags: UINT): HResult; stdcall;
    function InvokeCommand(var lpici: TCMInvokeCommandInfo): HResult; stdcall;
    function GetCommandString(idcmd: UINT; uType: UINT; pwreserved: puint;
      pszName: LPStr; cchMax: uint): HResult; stdcall;
  end;

const
  Class_ContextMenu: TGUID = '{3ff174ae-e8bd-4d3d-95b9-9bb9cc6d4a91}';


var
  numFiles: integer;
  fileList: TStringList;

implementation

uses SysUtils, ShellApi, Registry;

// ?????? ?????????? ??????
function isArray(ext: string): boolean;
const
  FileExt: array [0 .. 2] of string =
      ('.jpg', '.jpeg', '.bmp');
//    ('.gif', '.jpg', '.jpeg', '.png', '.jpe', '.bmp', '.jfif', '.dib', '.rle');
var
  i: integer;
begin
  Result := False;
  for i := 0 to 2 do
    if LowerCase(ext) = FileExt[i] then
      // ??????????. ??????? ? ?????? ???????.
      Result := True;
end;

function isImageFiles: boolean;
var
  i, k: integer;
  fileName: string;
  ext: string;
  sl: TStringList;
begin
  Result := False;
  sl := TStringList.Create;
  k := fileList.Count - 1;
  for i := 0 to k do
  begin
    fileName := fileList.Strings[i];
    ext := ExtractFileExt(fileName);
    if isArray(ext) then
    begin
      Result := True;
      sl.Add(fileName);
    end;
  end;
  fileList.Text := sl.Text;

  sl.Free;
end;

function TContextMenu.SEIInitialize(pidlFolder: PItemIDList;
  lpdobj: IDataObject; hKeyProgID: HKEY): HResult; stdcall;
var
  StgMedium: TStgMedium;
  FormatEtc: TFormatEtc;
  i: integer;
begin
  // ???? ?? ???????? ?? ?????? ????? - ?????
  if (lpdobj = nil) then
  begin
    Result := E_INVALIDARG;
    Exit;
  end;
  // ????????? FormatEtc (?? ??? ???? ???)
  with FormatEtc do
  begin
    cfFormat := CF_HDROP;
    ptd := nil;
    dwAspect := DVASPECT_CONTENT;
    lindex := -1;
    tymed := TYMED_HGLOBAL;
  end;
  // ?????? ?????????? lpdobj
  Result := lpdobj.GetData(FormatEtc, StgMedium);

  if Failed(Result) then
    Exit;

  // ?????? ?????????? ??????
  numFiles := DragQueryFile(StgMedium.hGlobal, $FFFFFFFF, nil, 0);

  if numFiles > 0 then
  begin
    fileList := TStringList.Create;
    {
      ?????????? ???? ??????.
    }
    for i := 0 to numFiles - 1 do
    begin
      FFileName := '';
      if DragQueryFile(StgMedium.hGlobal, i, FFileName, MAX_PATH) = 0 then
      begin
        Result := E_INVALIDARG;
        break;
      end;
      fileList.Add(FFileName);
    end;
  end
  else
    Result := E_INVALIDARG;

  if not isImageFiles then
    Result := E_INVALIDARG;

  ReleaseStgMedium(StgMedium);
end;

function UTF8ToSys(const s: string): string;
begin
  Result := UTF8ToAnsi(s);
end;

function TContextMenu.QueryContextMenu(Menu: HMENU;
  indexMenu, idCmdFirst, idCmdLast, uFlags: UINT): HResult; stdcall;
begin
  Result := 0; // or use MakeResult(SEVERITY_SUCCESS, FACILITY_NULL, 0);

  if ((uFlags and $0000000F) = CMF_NORMAL) or ((uFlags and CMF_EXPLORE) <> 0) then
  begin
    InsertMenu(Menu, indexMenu, MF_STRING or MF_BYPOSITION, idCmdFirst,PChar('  JPG < -- > BMP '));
    Result := 1; // or use MakeResult(SEVERITY_SUCCESS, FACILITY_NULL, 1)
  end;
end;

function FormatList: string;
var
  i, k: integer;
  s, p, t: string;
begin
  if fileList.Count = 0 then
    Exit;
  t := fileList.Strings[0];
  p := ExtractFilePath(t);
  s := '-p';// ???? ??????????? ?????
  s := s + ' "' + p + '" ';
  k := fileList.Count - 1;
  for i := 0 to k do
  begin
    t := fileList.Strings[i];
    if ExtractFilePath(t) = p then
      s := s + '"*' + ExtractFileName(t) + '" '
    else
      s := s + '"' + t + '" ';
  end;
  Result := s;
end;

procedure RunFA(FFileName: string);
var
  // ????????? ??????????-??????
  str: PChar;
  FilePath: array [0 .. MAX_PATH] of char;
  fileName: PChar;
begin
  FillChar(FilePath, sizeof(FilePath), #0);
  GetModuleFileName(hInstance, FilePath, sizeof(FilePath));
  fileName := PChar(ExtractFilePath(FilePath) + 'AppName.exe');
  str := PChar(FormatList);
  ShellExecute(hInstance, 'open', fileName, str, nil, SW_SHOWNORMAL);
  fileList.Clear;
end;

function TContextMenu.InvokeCommand(var lpici: TCMInvokeCommandInfo): HResult;
  stdcall;
begin
  // lpici.
  RunFA(FFileName);
  Result := NOERROR;
end;

function TContextMenu.GetCommandString(idcmd: UINT; uType: UINT;
  pwreserved: puint; pszName: LPStr; cchMax: uint): HResult; stdcall;
begin
  if (idCmd = 0) then
  begin
    if (uType = GCS_HELPTEXT) then
      // help string
      StrCopy(pszName, 'iLoader Plus');
    Result := NOERROR;
  end
  else
    Result := E_INVALIDARG;
end;

type
  TContextMenuFactory = class(TComObjectFactory)
  public
    procedure UpdateRegistry(Register: boolean); override;
  end;

// ????????? ???????????\????????????? ???? dll ? ???????
// ?????????? ???????? regsvr32 FAContMenu.dll ? cmd.exe
// ?????????????: regsvr32 /u FAContMenu.dll
procedure TContextMenuFactory.UpdateRegistry(Register: boolean);
var
  ClassIDs: string;
begin
  ClassIDs := GUIDToString(Class_ContextMenu);
  if Register then
  begin
    inherited UpdateRegistry(Register);
    with TRegistry.Create do
      try
        RootKey := HKEY_CLASSES_ROOT;
        OpenKey('\*\ShellEx\ContextMenuHandlers\AppName', True);
        WriteString('', ClassIDs);
      finally
        Free;
      end;
    // ???? ?????????? ? ?????????????? ?????, ????? ????????? ?????? ???? dll
    begin
      with TRegistry.Create do
        try
          RootKey := HKEY_LOCAL_MACHINE;
          OpenKey('\SOFTWARE\Microsoft\Windows\CurrentVersion\Shell Extensions\Approved',
            True);
          // OpenKey('Approved', True);
          WriteString(ClassIDs, 'AppName');
        finally
          Free;
        end;
    end;
  end
  else // ???????? ???????????
  begin
    with TRegistry.Create do
      try
        RootKey := HKEY_CLASSES_ROOT;
        DeleteRegKey('\*\ShellEx\ContextMenuHandlers\AppName');
      finally
        Free;
      end;
    with TRegistry.Create do
      try
        RootKey := HKEY_LOCAL_MACHINE;
        OpenKey('\SOFTWARE\Microsoft\Windows\CurrentVersion\Shell Extensions\Approved',
          True);
        DeleteValue(ClassIDs);
      finally
        Free;
      end;
    inherited UpdateRegistry(Register);
  end;
  SHChangeNotify(SHCNE_ASSOCCHANGED, SHCNF_IDLIST, nil, nil);
end;

initialization

  TContextMenuFactory.Create(ComServer, TContextMenu, Class_ContextMenu, '',
    'AppName', ciMultiInstance, tmApartment);

end.




